
(* Klnfle tpus rtkek deklarlsa *)

val harom = 2 + 1;
val MHz = 94.5;
val veege = true;
val kisA = #"a";
val palindrom = "ABBA";
val kisebb = LESS;
val ezNemSemmi = ();
val rat = {num = 3, den = 4};
val bLista = [2,3,4] @ [3,2];
val telenek = [0w123, 0wxcd];

(* Tpusmegkts *)
val id = fn (n : int) => n;
id 3;
id 4.5;
val elojeltelenek = [0w65, 0wx41 : word8];

(* Fggvny definilsa s alkalmazsa *) 

fun kovKod 00 = 01
  | kovKod 01 = 11
  | kovKod 11 = 10
  | kovKod 10 = 00;

kovKod 01;

(* Fggvny definilsa fggvnykifejezssel *) 

val kovKod = fn 00 => 01 | 01 => 11 | 11 => 10 | 10 => 00;

(* Fggvny definilsa case-kifejezssel *) 

fun kovKod c = case c of 00 => 01
                       | 01 => 11
		       | 11 => 10
		       | 10 => 00;

(* Egymsba gyazott case-kifejezsek *)

fun kovKod c = case c of 00 => 01
                       | d => case d of 01 => 11
		       | 11 => 10
		       | 10 => 00;

(* Egymsba gyazott case-kifejezsek *)

fun kovKod c = case c of 00 => 01
                       | d => case d of 01 => 11
		                      | 11 => 10
		                      | 10 => 00;

(* Egymsba gyazott case-kifejezsek *)

fun kovKod c = case c of 00 => 01
                       | d => (case d of 01 => 11
		                       | 11 => 10
                              )
		       | 10 => 00;

(* Hibajelzs kivteljelzssel *) 

fun kovKod c = case c of 00 => 01
                       | 01 => 11
		       | 11 => 10
		       | 10 => 00
		       | _  => raise Domain;

(* Kifejezsek, deklarcik *)

#den {num=1, den=2};
val xy = "}XY";
fun ++ x y = x ^ y;
type Rat = {num : int, den : int};
infixr 4 ++; fun x ++ y = x ^ y;

(* Deklarcik, ktsek *)

val even = fn 0 => true | x => not(odd x) and odd = fn 0 => false | y => not(even y);
fun (f o g) x = g(f x);
